import type {CodegenConfig} from '@graphql-codegen/cli';

const config: CodegenConfig = {
  schema: 'https://graphql.anilist.co',
  documents: './src/network/queries/**/*.graphql',
  generates: {
    './src/network/queries/models/types.ts': {
      plugins: ['typescript'],
      config: {
        skipTypeNameForRoot: true,
        skipTypename: true,
      },
    },
    './src/network/queries/models': {
      preset: 'near-operation-file',
      presetConfig: {
        extension: '.generated.tsx',
        baseTypesPath: 'types.ts',
      },
      plugins: ['typescript-operations', 'typescript-react-apollo'],
      config: {
        skipTypeNameForRoot: true,
        skipTypename: true,
      },
    },
  },
  hooks: {
    afterOneFileWrite: ['prettier --write'],
  },
};
export default config;
