import AsyncStorage from '@react-native-async-storage/async-storage';

export enum StorageKey {
  DATAUSER = 'data-user',
}

export const setStorageObjectData = async (key: StorageKey, value: any) => {
  try {
    const jsonValue = JSON.stringify(value);
    await AsyncStorage.setItem(key, jsonValue);
  } catch (e) {
    console.error('storage', e);
  }
};
export const setStorageData = async (value: string) => {
  try {
    await AsyncStorage.setItem('my-key', value);
  } catch (e) {
    console.error('storage', e);
  }
};

export const getStorageData = async (key: StorageKey) => {
  try {
    const value = await AsyncStorage.getItem(key);
    if (value !== null) {
      // value previously stored
      return value;
    }
  } catch (e) {
    console.error('storage', e);
  }
};

export const getStorageObjectData = async <T>(key: StorageKey): Promise<T | undefined> => {
  try {
    const value = await AsyncStorage.getItem(key);
    if (value !== null) {
      // value previously stored
      const jsonParse: T = JSON.parse(value);
      return jsonParse;
    }
  } catch (e) {
    console.error('storage', e);
  }
};
